"""
DO NOT EDIT THIS FILE!!
This file is automatically generated by the process_schemas.py program
in the scripts directory. It is not intended to be edited directly. If
you need to update the GEL protocol classes, please run the script
on the appropriate schema version.
"""
from protocols.protocol import (
    ProtocolElement,
    avro_parse,
    load_schema,
)


class ServiceHealth(ProtocolElement):
    """
    No documentation
    """

    # load schema from file
    _schemaSource = load_schema(__file__)
    # parse into avro classes
    schema = avro_parse(_schemaSource)

    requiredFields = {
        "datetime",
        "dependencies",
        "requestUrl",
        "serviceName",
        "status",
    }

    @classmethod
    def getEmbeddedTypes(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_8_2 import system as system_0_1_0

        return {
            "dependencies": system_0_1_0.Dependencies,
        }

    @classmethod
    def getEmbeddedEnums(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_8_2 import system as system_0_1_0

        return {
            "status": system_0_1_0.Status,
        }

    @classmethod
    def getEmbeddedByNamespace(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_8_2 import system as system_0_1_0

        return {
            "org.gel.models.system.avro.Dependencies": system_0_1_0.Dependencies,
            "org.gel.models.system.avro.Status": system_0_1_0.Status,
            "org.gel.models.system.avro.ServiceHealth": system_0_1_0.ServiceHealth,
        }

    __slots__ = [
        "datetime",
        "dependencies",
        "requestUrl",
        "serviceName",
        "status",
    ]

    def __init__(
        self,
        datetime,
        dependencies,
        requestUrl,
        serviceName,
        status,
        validate=None,
        **kwargs
    ):
        """Initialise the system_0_1_0.ServiceHealth model.

        :param datetime:
        :type datetime: str
        :param dependencies:
        :type dependencies: Dependencies
        :param requestUrl:
        :type requestUrl: str
        :param serviceName:
        :type serviceName: str
        :param status:
        :type status: Status
        """

        attributes = {k: v for k, v in locals().items() if k not in ["self", "unknown"]}
        ProtocolElement.__init__(self, **attributes)

    @classmethod
    def _namespace_version(cls):
        return "0.1.0"
